Index: issm/trunk/src/m/classes/sealevelmodel.js
===================================================================
--- issm/trunk/src/m/classes/sealevelmodel.js	(revision 26744)
+++ issm/trunk/src/m/classes/sealevelmodel.js	(revision 26744)
@@ -0,0 +1,143 @@
+class sealevelmodel {
+	/**
+	 * SEALEVELMODEL class definition
+	 * 
+	 * Usage:
+	 *     slm = sealevelmodel(varargin)
+	 *
+	 * Example:
+	 *     slm = sealevelmodel(
+	 *         'icecap', md_greenland,
+	 *         'icecap', md_antarctica,
+	 *         'earth', md_earth
+	 *     )
+	 *
+	 * TODO:
+	 * - Finish translation
+	 */
+	constructor(...varargin) {//{{{
+		this.icecaps = []; // list of land/ice models; name should be changed later
+		this.earth = null; // model for the whole earth
+		this.basins = []; // list of basins, matching icecaps, where shapefile info is held
+		this.cluster = null;
+		this.miscellaneous = null;
+		this.settings = null;
+		this.private = null;
+		this.mergedcaps = null;
+		this.transitions = [];
+		this.eltransitions = [];
+		this.planet = '';
+
+		this.setdefaultparamters();
+
+		if (varargin.length) {
+			let options = pairoptions(varargin);
+
+			// Recover all the icecap models
+			this.icecaps = options.getfieldvalues('ice_cap', []);
+
+			// Recover the earth model
+			this.earth = options.getfieldvalue('earth', 0);
+
+			// Set planet type
+			this.planet = options.getfieldvalue('planet', 'earth');
+		}
+	} //}}}
+
+	setdefaultparamters() {//{{{
+		// Initialize subclasses
+		this.icecaps = [];
+		this.earth = [];
+		this.cluster = generic();
+		this.miscellaneous = miscellaneous();
+		this.settings = issmsettings();
+		this.private = private();
+		this.transitions = [];
+		this.eltransitions = [];
+		this.planet = 'earth';
+	} //}}}
+
+	static checkconsistency(slm, solutiontype) {//{{{
+		// Is the coupler turned on?
+		for (let i = 0; slm.icecaps.length; ++i) {
+			if (!slm.icecaps[0].transient.iscoupler) {
+				console.log('sealevelmodel checkconsistency error: icecap model ' +  slm.icecaps[0].miscellaneous.name + ' should have the transient coupler option turned on!');
+			}
+		}
+
+		if (!slm.earth.transient.iscoupler) {
+			console.log('sealevelmodel checkconsistency error: earth model should have the transient coupler option turned on!');
+		}
+
+		// Check that the transition vectors have the right size
+		for (let i = 0; i < slm.icecaps.length; ++i) {
+			if (slm.icecaps[0].mesh.numberorvertices != slm.earth.solidearth.transitions[0].length) {
+				error('sealevelmodel checkconsistency issue with size of transition vector for ice cap: ' + i + ' name: ' + slm.icecaps[0].miscellaneous.name);
+			}
+		}
+
+		// Check that runfrequency is the same everywhere
+		for (let i = 0; i < slm.icecaps; ++i) {
+			if (slm.icecaps[i].solidearth.settings.runfrequency != slm.earth.solidearth.settings.runfrequency) {
+				error('sealevelmodel checkconsistency error: icecap model ' + slm.icecaps[i].miscellaneous.name + ' should have the same run frequency as earth!');
+			}
+		}
+
+		// Make sure steric_rate is the same everywhere
+		for (let i = 0; i < slm.icecaps.length; ++i) {
+			let md = slm.icecaps[i];
+			if (!isempty(find(md.dsl.steric_rate - slm.earth.dsl.steric_rate[slm.earth.dsl.transitions[i]]))) {
+				error('steric rate on ice cap ' + md.miscellaneous.name + ' is not the same as for the earth');
+			}
+		}
+
+		// Make sure grd is the same everywhere
+		for (let i = 0; i < slm.icecaps.length; ++i) {
+			let md = slm.icecaps[i];
+			if (md.solidearthsettings.isgrd != slm.earth.solidearthsettings.isgrd) {
+				error('isgrd on ice cap ' + md.miscellaneous.name + ' is not the same as for the earth');
+			}
+		}
+
+		// Make sure that there is no solid earth external forcing on the basins
+		for (let i = 0; i < slm.icecaps.length; ++i) {
+			let md = slm.icecaps[i];
+			if (!isempty(md.solidearth.external)) {
+				error('cannot run external forcings on an ice sheet when running a coupling earth/ice sheet model');
+			}
+		}
+
+		// Make sure that we have the right grd model for computing out sealevel patterns
+		for (let i = 0; i < slm.icecaps.length; ++i) {
+			let md = slm.icecaps[i];
+			if (md.solidearth.settings.grdmodel) {
+				error('sealevelmodel checkconsistency error message: ice sheets do not run GRD module, specify solidearth.settings.grdmodel=0 on ice cap ' + i);
+			}
+		}
+	} //}}}
+
+	disp() {//{{{
+		console.log('WARNING: sealevelmodel::disp is not yet implemented');
+	} //}}}
+
+	mergeresults() {//{{{
+		let champs = fieldnames(this.icecaps[0].results.TransientSolution);
+		for (let i = 0; i < this.mergedcaps.length / 2; ++i) {
+			let md = this.mergedcaps[2 * i];
+			let trans = this.mergedcaps[2 * i + 1];
+			//let icecaps = this.icecaps[this.range[2 * i + 2]];
+			for (let j = 0; j < this.icecaps[0].results.TransientSolution) {
+				for (let k = 0; champs.length; ++k) {
+					if (strcmpi(typeof(icecaps[0].results.TransientSolution[j][champs[k]]) == 'double')) {
+						// Vertex or element?
+						if (icecaps[0].results.TransientSolution[j][champs[k]].length == icecaps[0].mesh.numberofvertices) {
+							md.results.TransientSolution[j][champs[k]] == icecaps[0].mesh.numberofvertices;
+
+						}
+					} else {
+
+					}
+				}
+			}
+	} //}}}
+}
Index: issm/trunk/src/m/classes/sealevelmodel.m
===================================================================
--- issm/trunk/src/m/classes/sealevelmodel.m	(revision 25994)
+++ issm/trunk/src/m/classes/sealevelmodel.m	(revision 26744)
@@ -4,7 +4,7 @@
 %      slm = sealevelmodel(varargin)
 %
-%      where varargin is a variable list of options: 
+%      where varargin is a variable list of options:
 %
-%   Example: 
+%   Example:
 %      slm = sealevel('icecap',md_greenland,'icecap',md_antarctica,'earth',md_earth);
 
@@ -14,5 +14,5 @@
 		icecaps          = {}; % list of land/ice models, name should  be change longer term.
 		earth            = 0;  % model for the whole earth
-		basins           = {}; % list  of basins, matching icecaps, where shapefile info is held.
+		basins           = {}; % list of basins, matching icecaps, where shapefile info is held
 		cluster          = 0;
 		miscellaneous    = 0;
@@ -33,11 +33,11 @@
 				options=pairoptions(varargin{:});
 
-				%recover all the icecap models: 
-				slm.icecaps=getfieldvalues(options,'ice_cap',{}); 
+				%recover all the icecap models:
+				slm.icecaps=getfieldvalues(options,'ice_cap',{});
 				
 				%recover the earth model:
 				slm.earth = getfieldvalue(options,'earth',0);
 
-				%set planet type: 
+				%set planet type:
 				slm.planet=getfieldvalue(options,'planet','earth');
 
@@ -47,34 +47,58 @@
 		function checkconsistency(slm,solutiontype) % {{{
 
-			%is the coupler turned on? 
+			%is the coupler turned on?
 			for i=1:length(slm.icecaps),
 				if slm.icecaps{i}.transient.iscoupler==0,
-					warning(sprintf('sealevelmodel checkconsistenty error:  icecap model %s should have the transient coupler option turned on!',slm.icecaps{i}.miscellaneous.name));
+					warning(sprintf('sealevelmodel.m::checkconsistency: icecap model %s should have the transient coupler option turned on!',slm.icecaps{i}.miscellaneous.name));
 				end
 			end
 				
 			if slm.earth.transient.iscoupler==0,
-				warning('sealevelmodel checkconsistenty error:  earth model should have the transient coupler option turned on!');
-			end
-
-			%check that the transition vectors have the right size: 
-			for i=1:length(slm.icecaps),
-				if slm.icecaps{i}.mesh.numberofvertices ~= length(slm.earth.slr.transitions{i}),
-					error(['sealevelmodel checkconsistenty issue with size of transition vector for ice cap: ' num2str(i) ' name: ' slm.icecaps{i}.miscellaneous.name]);
-				end
-			end
-			
-			%check that run_frequency is the same everywhere: 
-			for i=1:length(slm.icecaps),
-				if slm.icecaps{i}.slr.geodetic_run_frequency~=slm.earth.slr.geodetic_run_frequency,
-					error(sprintf('sealevelmodel checkconsistenty error:  icecap model %s should have the same run frequency as earth!',slm.icecaps{i}.miscellaneous.name));
-				end
-			end
-
-			%make sure steric_rate is the same everywhere: 
-			for i=1:length(slm.icecaps),
-				md= slm.icecaps{i}; 
-				if ~isempty(find(md.slr.steric_rate - slm.earth.slr.steric_rate(slm.earth.slr.transitions{i}))),
-					error(sprintf('steric rate on ice cap %s is not the same as for the earth\n',md.miscellaneous.name));
+				warning('sealevelmodel.m::checkconsistency: earth model should have the transient coupler option turned on!');
+			end
+
+			%check that the transition vectors have the right size:
+			for i=1:length(slm.icecaps),
+				if slm.icecaps{i}.mesh.numberofvertices ~= length(slm.earth.solidearth.transitions{i}),
+					error(['sealevelmodel.m::checkconsistency: issue with size of transition vector for ice cap: ' num2str(i) ' name: ' slm.icecaps{i}.miscellaneous.name]);
+				end
+			end
+			
+			%check that runfrequency is the same everywhere:
+			for i=1:length(slm.icecaps),
+				if slm.icecaps{i}.solidearth.settings.runfrequency~=slm.earth.solidearth.settings.runfrequency,
+					error(sprintf('sealevelmodel.m::checkconsistency: icecap model %s should have the same run frequency as earth!',slm.icecaps{i}.miscellaneous.name));
+				end
+			end
+
+			%make sure steric_rate is the same everywhere:
+			for i=1:length(slm.icecaps),
+				md= slm.icecaps{i};
+				if ~isempty(find(md.dsl.steric_rate - slm.earth.dsl.steric_rate(slm.earth.dsl.transitions{i}))),
+					error(sprintf('sealevelmodel.m::checkconsistency: steric rate on ice cap %s is not the same as for the earth\n',md.miscellaneous.name));
+				end
+			end
+
+			%make sure grd is the same everywhere:
+			for i=1:length(slm.icecaps),
+				md= slm.icecaps{i};
+				if md.solidearthsettings.isgrd~=slm.earth.solidearthsettings.isgrd
+					error(sprintf('sealevelmodel.m::checkconsistency: isgrd on ice cap %s is not the same as for the earth\n',md.miscellaneous.name));
+				end
+			end
+
+			%make sure that there is no solid earth external forcing on the basins:
+			for i=1:length(slm.icecaps),
+				md= slm.icecaps{i};
+				if ~isempty(md.solidearth.external),
+					error('sealevelmodel.m::checkconsistency: cannot run external forcings on an ice sheet when running a coupling earth/ice sheet model');
+				end
+
+			end
+			%make sure that we have the right grd model for computing out sealevel patterns:
+			for i=1:length(slm.icecaps),
+				md= slm.icecaps{i};
+				if md.solidearth.settings.grdmodel~=0
+					error(sprintf('sealevelmodel.m::checkconsistency: ice sheets do not run GRD module, specify solidearth.settings.grdmodel=0 on ice cap %i',i));
 				end
 			end
@@ -111,5 +135,5 @@
 					for k=1:length(champs),
 						if strcmpi(class(icecaps{1}.results.TransientSolution(j).(champs{k})),'double'),
-							%vertex or element? 
+							%vertex or element?
 							if length(icecaps{1}.results.TransientSolution(j).(champs{k}))==icecaps{1}.mesh.numberofvertices,
 								md.results.TransientSolution(j).(champs{k})=zeros(md.mesh.numberofvertices,1);
@@ -118,5 +142,5 @@
 									md.results.TransientSolution(j).(champs{k})(trans{l})=resultcap;
 								end
-							else 
+							else
 								if strcmpi(champs{k},'IceVolume') | strcmpi(champs{k},'IceVolumeAboveFloatation') ,
 									md.results.TransientSolution(j).(champs{k})=0;
@@ -171,8 +195,8 @@
 		function intersections2d(self,varargin) % {{{
 
-			options=pairoptions(varargin{:}); 
+			options=pairoptions(varargin{:});
 			force=getfieldvalue(options,'force',0);
 			
-			%initialize, to avoid issues of having more transitions than meshes. 
+			%initialize, to avoid issues of having more transitions than meshes.
 			self.transitions={};
 			self.eltransitions={};
@@ -185,5 +209,5 @@
 				mdi=self.icecaps{i};
 		
-				%for elements: 
+				%for elements:
 				xei=mdi.mesh.x(mdi.mesh.elements)*[1;1;1]/3;
 				yei=mdi.mesh.y(mdi.mesh.elements)*[1;1;1]/3;
@@ -198,8 +222,8 @@
 		function intersections(self,varargin) % {{{
 
-			options=pairoptions(varargin{:}); 
+			options=pairoptions(varargin{:});
 			force=getfieldvalue(options,'force',0);
 			
-			%initialize, to avoid issues of having more transitions than meshes. 
+			%initialize, to avoid issues of having more transitions than meshes.
 			self.transitions={};
 			self.eltransitions={};
@@ -214,5 +238,5 @@
 				mdi=TwoDToThreeD(mdi,self.planet);
 		
-				%for elements: 
+				%for elements:
 				xei=mdi.mesh.x(mdi.mesh.elements)*[1;1;1]/3;
 				yei=mdi.mesh.y(mdi.mesh.elements)*[1;1;1]/3;
@@ -241,5 +265,5 @@
 		end % }}}
 		function baslist=basinindx(self,varargin) % {{{
-			options=pairoptions(varargin{:}); 
+			options=pairoptions(varargin{:});
 			continent=getfieldvalue(options,'continent','all');
 			bas=getfieldvalue(options,'basin','all');
@@ -249,6 +273,6 @@
 				if length(continent)==1,
 					if strcmpi(continent{1},'all'),
-						%need to transform this into a list of continents: 
-						continent={}; 
+						%need to transform this into a list of continents:
+						continent={};
 						for i=1:length(self.basins),
 							continent{end+1}=self.basins{i}.continent;
@@ -263,6 +287,6 @@
 			else
 				if strcmpi(continent,'all'),
-					%need to transform this into a list of continents: 
-					continent={}; 
+					%need to transform this into a list of continents:
+					continent={};
 					for i=1:length(self.basins),
 						continent{end+1}=self.basins{i}.continent;
@@ -278,5 +302,5 @@
 				if length(bas)==1,
 					if strcmpi(bas{1},'all'),
-						%need to transform this into a list of basins: 
+						%need to transform this into a list of basins:
 						baslist=[];
 						for i=1:length(self.basins),
@@ -299,5 +323,5 @@
 					end
 				else
-					%we have a list of basin names: 
+					%we have a list of basin names:
 					baslist=[];
 					for i=1:length(bas),
@@ -350,6 +374,6 @@
 		function caticecaps(self,varargin) % {{{
 			
-			%recover options: 
-			options=pairoptions(varargin{:}); 
+			%recover options:
+			options=pairoptions(varargin{:});
 			tolerance=getfieldvalue(options,'tolerance',.65);
 			loneedgesdetect=getfieldvalue(options,'loneedgesdetect',0);
@@ -362,5 +386,5 @@
 			
 			%Plug all models together:
-			md=models{1}; 
+			md=models{1};
 			for i=2:length(models),
 				md=modelmerge3d(md,models{i},'tolerance',tolerance);
@@ -381,5 +405,5 @@
 			end %}}}
 	
-			%Plug into earth: 
+			%Plug into earth:
 			self.earth=md;
 
@@ -390,6 +414,6 @@
 		function caticecaps2d(self,varargin) % {{{
 
-			%recover options: 
-			options=pairoptions(varargin{:}); 
+			%recover options:
+			options=pairoptions(varargin{:});
 			tolerance=getfieldvalue(options,'tolerance',1e-5);
 			loneedgesdetect=getfieldvalue(options,'loneedgesdetect',0);
@@ -397,5 +421,5 @@
 
 			%Plug all models together:
-			md=models{1}; 
+			md=models{1};
 			for i=2:length(models),
 				md=modelmerge2d(md,models{i},'tolerance',tolerance);
@@ -413,5 +437,5 @@
 			end %}}}
 
-			%Plug into earth: 
+			%Plug into earth:
 			self.earth=md;
 
@@ -439,5 +463,5 @@
 		end % }}}
 		function transfer(self,string) % {{{
-			%Recover field size in one icecap: 
+			%Recover field size in one icecap:
 			eval(['n=size(self.icecaps{1}.' string ',1);']);
 			if n==self.icecaps{1}.mesh.numberofvertices,
@@ -447,5 +471,5 @@
 				end
 			elseif n==(self.icecaps{1}.mesh.numberofvertices+1),
-				%dealing with a transient dataset. 
+				%dealing with a transient dataset.
 				%check that all timetags are similar between all icecaps:  %{{{
 				for i=1:length(self.icecaps),
@@ -458,5 +482,5 @@
 					end
 				end
-				eval(['capfield1= self.icecaps{1}.' string ';']); 
+				eval(['capfield1= self.icecaps{1}.' string ';']);
 				times=capfield1(end,:);
 				nsteps=length(times);
@@ -490,5 +514,5 @@
 			mintimestep=Inf;
 			for  i=1:length(self.icecaps),
-				ic=self.icecaps{i}; 
+				ic=self.icecaps{i};
 				mintimestep=min(mintimestep, length(ic.results.TransientSolution));
 			end
@@ -498,5 +522,5 @@
 			
 			for  i=1:length(self.icecaps),
-				ic=self.icecaps{i}; 
+				ic=self.icecaps{i};
 				ic.results.TransientSolution=ic.results.TransientSolution(1:mintimestep);
 				self.icecaps{i}=ic;
Index: issm/trunk/src/m/classes/sealevelmodel.py
===================================================================
--- issm/trunk/src/m/classes/sealevelmodel.py	(revision 25994)
+++ issm/trunk/src/m/classes/sealevelmodel.py	(revision 26744)
@@ -1,4 +1,3 @@
 from copy import deepcopy
-import warnings
 
 import numpy as np
@@ -36,7 +35,7 @@
     """
 
-    def __init__(self, *args):  #{{{
-        self.icecaps = []  # list of land/ice models; name should be changed later
-        self.earth = 0  # model for the whole earth
+    def __init__(self, *args):  # {{{
+        self.icecaps = [] # list of land/ice models; name should be changed later
+        self.earth = 0 # model for the whole earth
         self.basins = []  # list of basins, matching icecaps, where shapefile info is held
         self.cluster = 0
@@ -62,5 +61,5 @@
             # Set planet type
             self.planet = options.getfieldvalue('planet', 'earth')
-    #}}}
+    # }}}
 
     def __repr__(self):  # {{{
@@ -72,5 +71,5 @@
 
         return s
-    #}}}
+    # }}}
 
     def setdefaultparameters(self):  # {{{
@@ -84,5 +83,5 @@
         self.eltransitions = []
         self.planet = 'earth'
-    #}}}
+    # }}}
 
     @staticmethod
@@ -91,25 +90,42 @@
         for i in range(len(slm.icecaps)):
             if not slm.icecaps[i].transient.iscoupler:
-                warnings.warn('sealevelmodel checkconsistency error: icecap model {} should have the transient coupler option turned on!'.format(slm.icecaps[i].miscellaneous.name))
+                print('Warning: sealevelmodel.py::checkconsistency: icecap model {} should have the transient coupler option turned on!'.format(slm.icecaps[i].miscellaneous.name))
 
         if not slm.earth.transient.iscoupler:
-            warnings.warn('sealevelmodel checkconsistency error: earth model should have the transient coupler option turned on!')
+            print('Warning: sealevelmodel.py::checkconsistency: earth model should have the transient coupler option turned on!')
 
         # Check that the transition vectors have the right size
         for i in range(len(slm.icecaps)):
             if slm.icecaps[i].mesh.numberofvertices != len(slm.earth.slr.transitions[i]):
-                raise Exception('sealevelmodel checkconsistency issue with size of transition vector for ice cap: {} name: {}'.format(i, slm.icecaps[i].miscellaneous.name))
+                raise Exception('sealevelmodel.py::checkconsistency: issue with size of transition vector for ice cap: {} name: {}'.format(i, slm.icecaps[i].miscellaneous.name))
 
         # Check that run frequency is the same everywhere
         for i in range(len(slm.icecaps)):
-            if slm.icecaps[i].slr.geodetic_run_frequency != slm.earth.geodetic_run_frequency:
-                raise Exception('sealevelmodel checkconsistency error: icecap model {} should have the same run frequency as earth!'.format(slm.icecaps[i].miscellaneous.name))
+            if slm.icecaps[i].solidearth.settings.runfrequency != slm.earth.solidearth.settings.runfrequency:
+                raise Exception('sealevelmodel.py::checkconsistency: icecap model {} should have the same run frequency as earth!'.format(slm.icecaps[i].miscellaneous.name))
 
         # Make sure steric_rate is the same everywhere
         for i in range(len(slm.icecaps)):
             md = slm.icecaps[i]
-            if np.nonzero(md.slr.steric_rate - slm.earth.slr.steric_rate[slm.earth.slr.transitions[i]]) != []:
-                raise Exception('steric rate on ice cap {} is not the same as for the earth'.format(md.miscellaneous.name))
-    #}}}
+            if np.nonzero(md.dsl.steric_rate - slm.earth.dsl.steric_rate[slm.earth.dsl.transitions[i]]) != []:
+                raise Exception('sealevelmodel.py::checkconsistency: steric rate on ice cap {} is not the same as for the earth'.format(md.miscellaneous.name))
+
+        # Make sure grd is the same everywhere
+        for i in range(len(slm.icecaps)):
+            md = slm.icecaps[i]
+            if md.solidearthsettings.isgrd != slm.earth.solidearthsettings.isgrd:
+                raise RuntimeError('sealevelmodel.py::checkconsistency: isgrd on ice cap {} is not the same as for the earth\n'.format(md.miscellaneous.name))
+
+        # Make sure that there is no solid earth external forcing on the basins
+        for i in range(len(slm.icecaps)):
+            md = slm.icecaps[i]
+            if md.solidearth.external:
+                raise RuntimeError('sealevelmodel.py::checkconsistency: cannot run external forcings on an ice sheet when running a coupling earth/ice sheet model')
+        # Make sure that we have the right grd model for computing our sealevel patterns
+        for i in range(len(slm.icecaps)):
+            md = slm.icecaps[i]
+            if md.solidearth.settings.grdmodel != 0:
+                raise RuntimeError('sealevelmodel.py::checkconsistency: ice sheets do not run GRD module, specify solidearth.settings.grdmodel=0 on ice cap {}'.format(i))
+    # }}}
 
     def mergeresults(self):  # {{{
@@ -118,4 +134,5 @@
             md = self.mergedcaps[2 * i]
             trans = self.mergedcaps[2 * i + 1]
+            #icecaps = self.icecaps[self.range[2 * i + 2]]
             for j in range(len(self.icecaps[0].results.TransientSolution)):
                 for k in range(len(champs)):
@@ -140,14 +157,14 @@
                         continue
             self.mergedcaps[2 * i] = md
-    #}}}
+    # }}}
 
     def listcaps(self):  # {{{
         for i in range(len(self.icecaps)):
             print('{}: {}'.format(i, self.icecaps[i].miscellaneous.name))
-    #}}}
+    # }}}
 
     def ncaps(self): #{{{
         return len(self.icecaps)
-    #}}}
+    # }}}
 
     def continents(self):  # {{{
@@ -156,5 +173,5 @@
             list.append = self.basins[i].continent
         return np.unique(list)
-    #}}}
+    # }}}
 
     def basinsfromcontinent(self, continent):  # {{{
@@ -164,5 +181,5 @@
                 list.append = self.basins[i].name
         return np.unique(list)
-    #}}}
+    # }}}
 
     def addbasin(self, bas):  # {{{
@@ -170,5 +187,5 @@
             raise Exception('addbasin method only takes a \'basin\' class object as input')
         self.basins.append(bas)
-    #}}}
+    # }}}
 
     def intersections2d(self, *args): #{{{
@@ -195,7 +212,7 @@
             self.transitions.append(meshintersect2d(self.earth.mesh.x, self.earth.mesh.y, mdi.mesh.x, mdi.mesh.y, 'force', force))
             self.eltransitions.append(meshintersect2d(xe, ye, xei, yei, 'force', force))
-    #}}}
-
-    def intersections(self, *args):  #{{{
+    # }}}
+
+    def intersections(self, *args):  # {{{
         options = pairoptions(*args)
         force = options.getfieldvalue('force', 0)
@@ -223,19 +240,19 @@
             self.transitions.append(meshintersect3d(self.earth.mesh.x, self.earth.mesh.y, self.earth.mesh.z, mdi.mesh.x, mdi.mesh.y, mdi.mesh.z, 'force', force))
             self.eltransitions.append(meshintersect3d(xe, ye, ze, xei, yei, zei, 'force', force))
-    #}}}
-
-    def checkintersections(self):  #{{{
+    # }}}
+
+    def checkintersections(self):  # {{{
         flags = np.zeros(self.earth.mesh.numberofvertices, 1)
         for i in range(len(self.basins)):
             flags[self.transitions[i]] = i
         plotmodel(self.earth, 'data', flags, 'coastline', 'on')
-    #}}}
-
-    def checkbasinconsistency(self):  #{{{
+    # }}}
+
+    def checkbasinconsistency(self):  # {{{
         for i in range(len(self.basins)):
             self.basins[i].checkconsistency()
-    #}}}
-
-    def basinindx(self, *args):  #{{{
+    # }}}
+
+    def basinindx(self, *args):  # {{{
         options = pairoptions(*args)
         continent = options.getfieldvalue('continent', 'all')
@@ -264,5 +281,5 @@
             else:
                 pass  # Nothing to do: assume we have a list of continents
-        #}}}
+        # }}}
 
         # Expand basins list using the continent list above and the extra bas discriminator #{{{
@@ -309,20 +326,20 @@
 
         return baslist
-        #}}}
-    #}}}
-
-    def addicecap(self, md):  #{{{
+        # }}}
+    # }}}
+
+    def addicecap(self, md):  # {{{
         if not type(md) == model:
             raise Exception("addicecap method only takes a 'model' class object as input")
 
         self.icecaps.append(md)
-    #}}}
-
-    def basinsplot3d(self, *args):  #{{{
+    # }}}
+
+    def basinsplot3d(self, *args):  # {{{
         for i in range(len(self.basins)):
             self.basins[i].plot3d(*args)
-    #}}}
-
-    def caticecaps(self, *args):  #{{{
+    # }}}
+
+    def caticecaps(self, *args):  # {{{
         # Recover options
         options = pairoptions(*args)
@@ -356,7 +373,7 @@
         # Create mesh radius
         self.earth.mesh.r = planetradius('earth') * np.ones((md.mesh.numberofvertices, ))
-    #}}}
-
-    def caticecaps2d(self, *args):  #{{{
+    # }}}
+
+    def caticecaps2d(self, *args):  # {{{
         # Recover options
         options = pairoptions(*args)
@@ -382,7 +399,7 @@
         # Plug into earth
         self.earth = md
-    #}}}
-
-    def viscousiterations(self):  #{{{
+    # }}}
+
+    def viscousiterations(self):  # {{{
         for i in range(len(self.icecaps)):
             ic = self.icecaps[i]
@@ -391,7 +408,7 @@
                 mvi = np.max(mvi, ic.results.TransientSolution[j].StressbalanceConvergenceNumSteps)
             print("{}, {}: {}".format(i, self.icecaps[i].miscellaneous.name, mvi))
-    #}}}
-
-    def maxtimestep(self):  #{{{
+    # }}}
+
+    def maxtimestep(self):  # {{{
         for i in range(len(self.icecaps)):
             ic = self.icecaps[i]
@@ -403,7 +420,7 @@
         timei = self.earth.results.TransientSolution[-1].time
         print("Earth: {}/{}", mvi, timei)
-    #}}}
-
-    def transfer(self, string):  #{{{
+    # }}}
+
+    def transfer(self, string):  # {{{
         # Recover field size in one icecap
         n = getsubattr(self.icecaps[0], string).shape[0]
@@ -426,9 +443,9 @@
             times = capfield1[-1, :]
             nsteps = len(times)
-            #}}}
+            # }}}
             # Initialize #{{{
             field = np.zeros((self.earth.mesh.numberofvertices + 1, nsteps))
             field[-1, :] = times  # Transfer the times only, not the values
-            #}}}
+            # }}}
             # Transfer all the time fields #{{{
             for i in range(len(self.icecaps)):
@@ -437,5 +454,5 @@
                     field[self.transitions[i], j] = capfieldi[0:-1, j]  # Transfer only the values, not the time
             setsubattr(self.earth, string, field)  # Do not forget to plug the field variable into its final location
-            #}}}
+            # }}}
         elif n == (self.icecaps[0].mesh.numberofelements):
             setsubattr(self.earth, string, np.zeros((self.earth.mesh.numberofelements, ))) # Assign array of zeros to target attribute
@@ -445,7 +462,7 @@
         else:
             raise Exception('not supported yet')
-    #}}}
-
-    def homogenize(self, noearth=0):  #{{{
+    # }}}
+
+    def homogenize(self, noearth=0):  # {{{
         mintimestep = np.inf
 
@@ -470,10 +487,10 @@
 
         return self
-    #}}}
-
-    def initializemodels(self):  #{{{
+    # }}}
+
+    def initializemodels(self):  # {{{
         for i in range(len(self.basins)):
             md = model()
             md.miscellaneous.name = self.basins[i].name
             self.addicecap(md)
-    #}}}
+    # }}}
Index: issm/trunk/src/m/classes/slr.js
===================================================================
--- issm/trunk/src/m/classes/slr.js	(revision 25994)
+++ issm/trunk/src/m/classes/slr.js	(revision 26744)
@@ -114,5 +114,6 @@
 		} //}}}
 		this.marshall=function(md,prefix,fid) { //{{{
-
+			console.log('WARNING: NOT MARHSALLING SLR FOR NOW.');
+			return;
 			WriteData(fid,prefix,'object',this,'fieldname','deltathickness','format','DoubleMat','mattype',2);
 			WriteData(fid,prefix,'object',this,'fieldname','sealevel','mattype',1,'format','DoubleMat','timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
Index: issm/trunk/src/m/classes/slr.py
===================================================================
--- issm/trunk/src/m/classes/slr.py	(revision 25994)
+++ issm/trunk/src/m/classes/slr.py	(revision 26744)
@@ -7,13 +7,13 @@
 from planetradius import planetradius
 from WriteData import WriteData
+from project3d import project3d
 
 
 class slr(object):
-    '''
-    SLR class definition
-
-        Usage:
-          slr = slr()
-    '''
+    """SLR class definition
+
+    Usage:
+        slr = slr()
+    """
     def __init__(self):  # {{{
         self.deltathickness = np.nan
@@ -120,5 +120,5 @@
     def checkconsistency(self, md, solution, analyses):  # {{{
         # Early return
-        if 'SealevelriseAnalysis' not in analyses or (solution == 'TransientSolution' and not md.transient.isslr):
+        if 'SealevelchangeAnalysis' not in analyses or (solution == 'TransientSolution' and not md.transient.isslr):
             return md
 
@@ -153,5 +153,5 @@
         els = np.where(maskpos > 0)
         if len(els[0]) > 0:
-            warnings.warn('slr checkconsistency fail: there are elements with ice loads where some vertices are not on the ice!')
+            print('Warning: slr.py::checkconsistency: there are elements with ice loads where some vertices are not on the ice!')
 
         # Check that if geodetic is requested, we are a mesh3dsurface model (planet), or if we are not, a coupler to a planet model is provided
